import gleam/dynamic/decode.{type Decoder}
import spacetraders_models/agent_symbol.{type AgentSymbol}
import spacetraders_models/timestamp.{type Timestamp}
import spacetraders_models/waypoint_symbol.{type WaypointSymbol}

pub type Chart {
  Chart(
    waypoint_symbol: WaypointSymbol,
    submitted_by: AgentSymbol,
    submitted_on: Timestamp,
  )
}

pub fn decoder() -> Decoder(Chart) {
  use waypoint_symbol <- decode.field(
    "waypointSymbol",
    waypoint_symbol.decoder(),
  )
  use submitted_by <- decode.field("submittedBy", agent_symbol.decoder())
  use submitted_on <- decode.field("submittedOn", timestamp.decoder())
  decode.success(Chart(waypoint_symbol:, submitted_by:, submitted_on:))
}
